// 06/10/09 part of common-1.0
// 10/08/08 fix Salsa6 typo

#ifndef COOKIE_JAR_HPP
#define COOKIE_JAR_HPP

#include <cat/Platform.hpp>

namespace cat {


class CookieJar
{
	static const int EXPIRE_TIME = 4000; // ms
	static const int BIN_COUNT = 16; // power of 2
	static const int BIN_TIME = EXPIRE_TIME / BIN_COUNT;
	static const int BIN_MASK = BIN_COUNT - 1;

	u32 key[16];

protected:
	u32 Salsa6(u32 ip, u16 port, u32 epoch);

public:
	CookieJar();

	// Thread-safe and lock free
	u32 Generate(u32 ip, u16 port);
	bool Verify(u32 ip, u16 port, u32 cookie);
};


} // namespace cat

#endif // COOKIE_JAR_HPP
