// 06/10/09 part of common-1.0

#ifndef MMAPFILE_HPP
#define MMAPFILE_HPP

#include <cat/Platform.hpp>

#if defined(OS_WINDOWS)
# include <windows.h>
#endif

namespace cat {


class MMapFile
{
	char *data;
	u32 len;
	s32 offset;

#if defined(OS_LINUX)
	int fd;
#elif defined(OS_WINDOWS)
	HANDLE hFile, hMapping;
#endif

public:
	MMapFile(const char *path);
	~MMapFile();

	inline bool good() { return data != 0; }
	inline bool inside() { return offset >= 0 && offset < (s32)len; }

	inline u32 size() { return len; }

	inline void seek(s32 poffset) { offset = poffset; }
	inline bool underrun(s32 requested) { return (u32)(offset + requested) > len; }
	inline char *look() { return data + offset; }
	inline char *look(s32 offset) { return data + offset; }
	inline char *read(s32 requested) { offset += requested; return data + (offset - requested); }
	inline void skip(s32 requested) { offset += requested; }
	inline u32 remaining() { return len - offset; }
	inline u32 getOffset() { return offset; }
};


} // namespace cat

#endif // MMAPFILE_HPP
