// 06/10/09 part of common-1.0

#ifndef MESSAGE_ROUTER_HPP
#define MESSAGE_ROUTER_HPP

#include <parse/BitStream.hpp>
#include "FastDelegate.h"

namespace cat {


typedef fastdelegate::FastDelegate<void (BitStream &m)> MessageHandler;

class MessageRouter
{
	MessageHandler handlers[256];

public:
	void Set(u8 opcode, const MessageHandler &handler);
	void Clear(u8 opcode);

	void Invoke(u8 opcode, BitStream &msg);
};


} // namespace cat

#endif // MESSAGE_ROUTER_HPP
