// 06/10/09 part of common-1.0

#ifndef MUTEX_HPP
#define MUTEX_HPP

#include <cat/Platform.hpp>

#if defined(OS_WINDOWS)
# include <windows.h>
#endif

namespace cat {


class Mutex
{
	CRITICAL_SECTION cs;

public:
	Mutex();
	~Mutex();

	void Enter();
	void Leave();
};


class AutoMutex
{
	Mutex *mutex;

public:
	AutoMutex(Mutex &mutex);
	~AutoMutex();

	void Release();
};


} // namespace cat

#endif // MUTEX_HPP
