// 06/10/09 part of common-1.0

#ifndef CLOCK_HPP
#define CLOCK_HPP

#include <cat/Platform.hpp>
#include <string>

namespace cat {


class Clock
{
#ifdef OS_WINDOWS
	u32 period;
#endif

public:
	Clock();
	~Clock();

	static u32 sec(); 		// timestamp in seconds
	static u32 hsec(); 		// timestamp in hundredths of a second
	static u32 msec(); 		// timestamp in milliseconds
	static double usec(); 	// timestamp in microseconds

	static std::string format(const char *format_string);

	static void sleep(u32 milliseconds);
};


} // namespace cat

#endif // CLOCK_HPP
