#include <threads/Mutex.hpp>
using namespace cat;


//// Mutex

Mutex::Mutex()
{
	InitializeCriticalSection(&cs);
}

Mutex::~Mutex()
{
	DeleteCriticalSection(&cs);
}

void Mutex::Enter()
{
	EnterCriticalSection(&cs);
}

void Mutex::Leave()
{
	LeaveCriticalSection(&cs);
}


//// AutoMutex

AutoMutex::AutoMutex(Mutex &mutex)
{
	this->mutex = &mutex;
	mutex.Enter();
}

AutoMutex::~AutoMutex()
{
	Release();
}

void AutoMutex::Release()
{
	if (mutex)
	{
		mutex->Leave();
		mutex = 0;
	}
}
